#include<stdio.h>
#include<stdarg.h>
#include<stdlib.h>
#include "types.h"
#include "defaults.h"
#include "pin.h"
#include "X.h"
#include "warning.h"
#include "timer.h"
#include "window.h"
#include "edit.h"
#include "keyboard.h"
#include "bindings.h"
#include "post.h"
#include "misc.h"
#include "loop.h"
#include "output.h"
#include "gsl.h"

static int vter = 1;
static int uvter = 0;

//: setFPSs

static double *FPSs = NULL;

void setFPSs (double prvni, ...)
{
  va_list vl;
  double d;

  if(FPSs) warning("rychlosti uz byly definovany");

  maxFPS = 0;
  va_start(vl, prvni);
  for(d=prvni; d; d = va_arg(vl, double)){
    maxFPS++;
  }
  va_end(vl);

  FPSs = malloc(maxFPS*sizeof(double));

  aktuFPS = maxFPS = -1;
  va_start(vl, prvni);
  for(d=prvni; d; d = va_arg(vl, double)){
    maxFPS++;
    if(d<0){
      if(aktuFPS >= 0) warning("aktualni FPS je vicenasobne");
      aktuFPS = maxFPS;
      d = -d;
    }
    FPSs[maxFPS] = d;
  }
  va_end(vl);

  if(aktuFPS == -1){
    warning("nenalezeno aktualni FPS");
    aktuFPS = 0;
  }

  setdelay(0, 1000000/FPSs[aktuFPS]);
}

//: zmenFPS

void zmenFPS(int oco)
{
  int i;

  if(!FPSs){
    warning("nenacteny rychlosti");
    return;
  }

  i = aktuFPS+oco;
  if(i<0) i=0;
  if(i>maxFPS) i = maxFPS;

  if(i != aktuFPS) setdelay(0, 1000000/FPSs[i]);
  aktuFPS = i;
  printf("FPS: %f\n", FPSs[i]);
}

//: setdelay

void setdelay (int vteriny, int mikro)
/***********************************/
{
  long int cas;

  cas = mikro + vteriny*1000000;
  if(cas>0){
    vter = cas/1000000;
    uvter = cas%1000000;
  }
  cekalose = 0;
}

//: udalosti

static void udalosti ()
/*********************/
{
  XEvent report;
  KeySym ks;
  char *ksname, ch;

  while (okrajtext || XEventsQueued(display, QueuedAfterReading)){
    if(okrajtext){
      cekalose = 1;
      updateposts();
    }
    XNextEvent(display, &report); // seberu udalost ze fronty nebo na ni cekam

    switch (report.type){

    case Expose:    // Pri odkryti textu
      redrawtext(); // je treba ho prekreslit.
      if(!okrajtext) mengraf = 1;
      break;

    case ButtonPress:      // Pri zmacknuti tlacitka na mysi
      popup_info("_help"); // se ukaze napoveda
      break;

    case KeyPress:    // Pri zmacknuti klavesy
      XLookupString (&report.xkey, NULL, 0, &ks, NULL);
      if (ks != NoSymbol && (ksname = XKeysymToString (ks))
	  && dobind(ksname)) break;     // zkusim spustit klavesovou zkratku

      ch = xkeyznak(&report);
      if(ch) pripisznak(ch);  // nebo alespon zmacknuty pripsat znak do spodniho radku
    }
  }
}

//: loop

void loop ()
/**********/
{
  struct timeval tv, ocas, ncas;
  long int i = 0;
  long int opakovani = 0;

  //  popup_sl("zkouska", (void (*)(char *))puts);

  gettimeofday(&ocas, NULL);
  for(;;){
    cekalose = 0;

    udalosti(); // zpracovavam udalosti

    dotimers(); // Provedu timery
    if(prvtimer) prvtimer-> zbyva--; //a posunu je o jednicku

    updateposts(); // provedu graficke
    kreslianim();  // zmeny

    if(opakovani) opakovani--;

    if(!opakovani){
      tv.tv_sec = vter;
      tv.tv_usec = uvter;
      select(0, NULL, NULL, NULL, &tv); // cekam
    }

    i++;
    gettimeofday(&ncas, NULL);
    if(ocas.tv_sec < ncas.tv_sec){/*
            printf("real FPS: %ld, ", i);
            printf("real delay: %ld\n", (ncas.tv_sec-ocas.tv_sec)*1000000
	    + (ncas.tv_usec-ocas.tv_usec));*/
      i=0;
    }

    if(!opakovani && !cekalose)
      opakovani =
	((ncas.tv_sec-ocas.tv_sec)*1000000 + (ncas.tv_usec-ocas.tv_usec))/
	(vter*10000000 + uvter);
    if(cekalose) opakovani = 0;

    ocas = ncas;
  }
}
